// score:100
#include <iostream>
#include <vector>
using namespace std;

vector<vector<int> > graph;
vector<bool> visited;
vector<pair<int, int> > sol;

bool solve(int n) {
  if (visited[n])
    return true;
  visited[n] = true;
  bool need_parent = false;
  for (size_t i=0; i<graph[n].adj.size(); ++i) {
    if (!solve(graph[n].adj[i])) {
      sol.push_back(make_pair(n, graph[n].adj[i]));
      need_parent = !need_parent;
    }
  }
  return need_parent;
}

int main() {
  ios_base::sync_with_stdio(false);
  int n, m; cin >> n >> m;
  graph.resize(n);
  visited.resize(n);
  while (m--) {
    int a, b; cin >> a >> b;
    graph[a].adj.push_back(b);
    graph[b].adj.push_back(a);
  }
  for (int i=0; i<n; ++i)
    if (!solve(i)) {
      cout << "NONE\n";
      return 0;
    }
  cout << sol.size() << '\n';
  for (size_t i=0; i<sol.size(); ++i)
    cout << sol[i].first << ' ' << sol[i].second << '\n';
}
